include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext MonoPattern

pSource equ ZW0
wVram equ ZW0
wCount equ ZW2
count equ ZB0
VramH equ ZB1


cseg
CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts
ColorSource:
defb 64, $f0 ; Ascii
defb 1, $70 ; Wall
defb 4, $f0 ; Knife
defb 88, $f0 ; Man
defb 4, $d0 ; Chaser
defb 4, $80 ; Disturber
defb 4, $f0 ; Goal
defb 4, $b0 ; Bang
defb 4, $f0 ; M
defb 4, $d0 ; A
defb 4, $a0 ; Z
defb 4, $80 ; Y
defb 0
cseg
InitVram: public InitVram
    sei
        lda #0 | sta <VramH
        do
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #$40 or high Vram_PatternGenerator | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_End
            jsr CopyToVdp

            lda #low Vram_Color | sta VdpWritePort+1
            lda #$40 or high Vram_Color | ora <VramH | sta VdpWritePort+1
            ldx #0
            do
                lda ColorSource,x
            while ne
                sta <count
                inx
                lda ColorSource,x | inx
                do
                    ldy #8
                    do
                        sta VdpWritePort
                        jsr WaitVdp
                        dey
                    while ne | wend
                    dec <count
                while ne | wend
            wend
            
            lda <VramH | clc|adc #8 | sta <VramH
            cmp #8*3
        while ne | wend
    cli
    WaitVdp: public WaitVdp
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            lda #low Vram_PatternName | sta VdpWritePort+1
            lda #$40 or high Vram_PatternName | sta VdpWritePort+1
            lda #Char_Space
            ldy #VramHeight
            do
                ldx #VramWidth
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                dey
            while ne | wend
        cli
    pla
rts


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda #0 | sta <wVram+1
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        asl	a | rol <wVram+1 ; *8
        asl	a | rol <wVram+1 ; *16
        asl	a | rol <wVram+1 ; *32

        clc|adc VramAddress_.x_ | tay
        lda <wVram+1 | adc #0 | tax

        tya clc|adc #low Vram | tay
        txa adc #high Vram | tax
	pla
rts


dseg
Put_@Param0: public Put_@Param0
Put_vram:
PrintC_@Param0: public PrintC_@Param0
PrintC_vram:
WriteVram_@Param0: public WriteVram_@Param0
WriteVram_vram:
ReadVram_@Param0: public ReadVram_@Param0
ReadVram_vram:
FillVram_@Param0: public FillVram_@Param0
FillVram_vram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
PrintC_@Param1: public PrintC_@Param1
PrintC_c:
WriteVram_@Param1: public WriteVram_@Param1
WriteVram_c:
FillVram_@Param1: public FillVram_@Param1
FillVram_b:
    defb 0


; ptr<byte> Put(word vram, byte c);
cseg
Put_: public Put_
    pha
        sei
            lda Put_vram | sta VdpWritePort+1
            lda Put_vram+1 | ora #$40 | sta VdpWritePort+1
            lda Put_c
            sta VdpWritePort
        cli
        lda Put_vram | clc|adc #1 | tay
        lda Put_vram+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    pha
        sei
            lda PrintC_vram | sta VdpWritePort+1
            lda PrintC_vram+1 | ora #$40 | sta VdpWritePort+1
            lda PrintC_c
            sec|sbc #$20
            sta VdpWritePort
        cli
        lda PrintC_vram | clc|adc #1 | tay
        lda PrintC_vram+1 | adc #0 | tax
    pla
rts


; void WriteVram(word vram, byte b);
cseg
WriteVram_: public WriteVram_
    sei
        lda WriteVram_vram | sta VdpWritePort+1
        lda WriteVram_vram+1 | ora #$40 | sta VdpWritePort+1
        lda WriteVram_c
        sta VdpWritePort
    cli
rts


; byte ReadVram(word vram);
cseg
ReadVram_: public ReadVram_
    sei
        lda ReadVram_vram | sta VdpWritePort+1
        lda ReadVram_vram+1 | sta VdpWritePort+1
        jsr WaitVdp
        ldy VdpReadPort
    cli
rts


; void FillVram(word vram, byte b, word count);
dseg
FillVram_@Param2: public FillVram_@Param2
FillVram_count:
    defw 0
cseg
FillVram_: public FillVram_
    pha
        lda FillVram_count | sta <wCount
        lda FillVram_count+1 | sta <wCount+1
        sei
            lda FillVram_vram | sta VdpWritePort+1
            lda FillVram_vram+1 | ora #$40 | sta VdpWritePort+1
            ldx FillVram_b
            do
                stx VdpWritePort
                jsr WaitVdp
                lda <wCount | sec | sbc #1 | sta <wCount
                lda <wCount+1 | sbc #0 | sta <wCount+1
                ora <wCount
            while ne | wend
        cli
    pla
rts


; void VVramToVram();
wSource equ ZW0
wDestination equ ZW1
yCount equ ZB0
dseg
rowBuff:
    defs VVramWidth
cseg
VVramToVram_: public VVramToVram_
    pha
        lda #low VVram | sta <wSource
        lda #high VVram | sta <wSource+1

        lda #low Vram | sta <wDestination
        lda #high Vram or $40 | sta <wDestination+1

        lda #VVramHeight | sta <yCount
        do
            sei
                lda <wSource | sta VdpWritePort+1
                lda <wSource+1 | sta VdpWritePort+1
                ldx #0
                do
                    jsr WaitVdp
                    lda VdpReadPort
                    sta rowBuff,x | inx
                    cpx #VVramWidth
                while ne | wend
            cli
            lda <wSource | clc|adc #VVramWidth | sta <wSource
            lda <wSource+1 | adc #0 | sta <wSource+1

            sei
                lda <wDestination | sta VdpWritePort+1
                lda <wDestination+1 | sta VdpWritePort+1
                ldx #0
                do
                    lda rowBuff,x | inx
                    sta VdpWritePort
                    jsr WaitVdp
                    cpx #VVramWidth
                while ne | wend
            cli
            lda <wDestination | clc|adc #VramWidth | sta <wDestination
            lda <wDestination+1 | adc #0 | sta <wDestination+1

            dec <yCount
        while ne | wend
    pla
rts